unit MyMain;
//------------------------------------
// example for a Monitor-Software for
// Allnet RF3000 (MK2)  & Allnet 3000
// programmed by M. Kuhn
// visit my Homepage: www.mathgame.de
//------------------------------------

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP;

type
  TForm1 = class(TForm)
    IP_RF3000: TEdit;
    IP_Allnet3000: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    StaticText4: TStaticText;
    EDate: TEdit;
    StaticText5: TStaticText;
    ETime: TEdit;
    StaticText6: TStaticText;
    EFirmware: TEdit;
    GridRFPlugs: TStringGrid;
    StaticText2: TStaticText;
    StaticText1: TStaticText;
    GridSensors: TStringGrid;
    CB_S1: TCheckBox;
    CB_S2: TCheckBox;
    CB_S3: TCheckBox;
    CB_S4: TCheckBox;
    CB_S5: TCheckBox;
    CB_S6: TCheckBox;
    CB_S7: TCheckBox;
    CB_S8: TCheckBox;
    Offset_S1: TEdit;
    Label3: TLabel;
    Nultiplier: TLabel;
    Mult_S1: TEdit;
    Offset_S2: TEdit;
    Mult_S2: TEdit;
    Offset_S3: TEdit;
    Mult_S3: TEdit;
    Offset_S4: TEdit;
    Mult_S4: TEdit;
    Offset_S5: TEdit;
    Mult_S5: TEdit;
    Offset_S6: TEdit;
    Mult_S6: TEdit;
    Offset_S7: TEdit;
    Mult_S7: TEdit;
    Offset_S8: TEdit;
    Mult_S8: TEdit;
    StaticText3: TStaticText;
    Display_S1: TLabel;
    Label5: TLabel;
    Unit_S1: TEdit;
    Unit_S2: TEdit;
    Unit_S3: TEdit;
    Unit_S4: TEdit;
    Unit_S5: TEdit;
    Unit_S6: TEdit;
    Unit_S7: TEdit;
    Unit_S8: TEdit;
    Display_S2: TLabel;
    Display_S3: TLabel;
    Display_S4: TLabel;
    Display_S5: TLabel;
    Display_S6: TLabel;
    Display_S7: TLabel;
    Display_S8: TLabel;
    BtnConnectRF3000: TButton;
    BtnConnectAllnet3000: TButton;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    Bevel1: TBevel;
    Bevel2: TBevel;
    IdHTTP1: TIdHTTP;
    IdHTTP2: TIdHTTP;
    TimerRF3000: TTimer;
    TimerAllnet3000: TTimer;
    StaticText9: TStaticText;
    EDate3000: TEdit;
    StaticText10: TStaticText;
    ETime3000: TEdit;
    StaticText11: TStaticText;
    EFirmware3000: TEdit;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    StaticText17: TStaticText;
    StaticText18: TStaticText;
    SName1: TLabel;
    SName2: TLabel;
    SName3: TLabel;
    SName4: TLabel;
    SName5: TLabel;
    SName6: TLabel;
    SName7: TLabel;
    SName8: TLabel;
    Bevel3: TBevel;
    procedure Clear3000RF;
    procedure ClearAllnet3000;
    procedure BtnConnectRF3000Click(Sender: TObject);
    procedure TimerRF3000Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnConnectAllnet3000Click(Sender: TObject);
    procedure TimerAllnet3000Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
Const
  MyTextfile = 'Allnet3000Monitor.ini';

var
  Form1: TForm1;
  MyError                   : Integer;
  MyConnectRF3000           : Boolean = False;
  MyConnectAllnet3000       : Boolean = False;
  MyCmd , RecvString        : String;
  MyHelpStr                 : String;
  i,j,k                     : Integer;
  Pos1,Pos2,MyStart,MyLen   : Integer;

  //RF3000 Variables
  RFSocketName     :  Array[0..15] of String;
  RFStatus         :  Array[0..15] of String;
  RTDate,RTTime    :  String;
  RFFirmwareStatus :  String;

  //Allnet 3000 Variables
  SensorStatus     :  Array[0..7] of String;
  SensorName       :  Array[0..7] of String;
  Min              :  Array[0..7] of String;
  Max              :  Array[0..7] of String;
  High             :  Array[0..7] of String;
  Low              :  Array[0..7] of String;
  Typ              :  Array[0..7] of String;

  RTDate3000,RTTime3000    :  String;
  RFFirmwareStatus3000     :  String;

  MyF                      : Textfile; 


implementation

{$R *.dfm}




Function MyXMLGet(MyString:String) : String;
begin
  Pos1 := Pos('<'   + MyString + '>' , RecvString );
  Pos2 := Pos('</'  + MyString + '>' , RecvString );

  MyXMLGet := '';
  If (Pos1 = 0) or (Pos2 = 0) then exit ;

  MyStart  :=        Pos1 +  (length(MyString) + 2 ) ;
  MyLen    := Pos2 - Pos1 -  (length(MyString) + 2 ) ;
  MyXMLGet := copy(RecvString, MyStart, MyLen);
end;

procedure TForm1.Clear3000RF;
begin
  for i := 0 to 15 do
    for j := 0 to 1
       do Form1.GridRFPlugs.cells[j,i] :='';

  Form1.EDate     .Text := '';
  Form1.ETime     .Text := '';
  Form1.EFirmware .Text := '';

end;

procedure TForm1.ClearAllnet3000;
begin
  for i := 0 to 7 do
    for j := 0 to 1
       do Form1.GridSensors.cells[j,i] :='';

end;

procedure TForm1.BtnConnectRF3000Click(Sender: TObject);
begin
      If MyConnectRF3000
        then begin
               MyConnectRF3000 := False;
               IdHTTP1.Disconnect;
               BtnConnectRF3000.Caption := 'Connect';
               TimerRF3000.Enabled      := False;
               Clear3000RF;
             end
        else begin
                 IdHTTP1.Host := IP_RF3000.Text;
               try
                 {$I-}
                   IdHTTP1.Connect;
                   MyConnectRF3000 := IdHTTP1.Connected;
                 {$I+}
               except
                 MyConnectRF3000 := False;
               end;

               If MyConnectRF3000
                 then begin
                        BtnConnectRF3000.Caption := 'Disconnect';
                        MyConnectRF3000          := True;
                        TimerRF3000.Enabled      := True;
                      end
                 else begin
                        showmessage('connection to 3000RF:' + IdHTTP1.Host + ' not possible');
                        BtnConnectRF3000.Caption := 'Connect';
                        MyConnectRF3000          := False;
                        TimerRF3000.Enabled      := False;
                      end;
             end;
end;


procedure TForm1.BtnConnectAllnet3000Click(Sender: TObject);
begin
      If MyConnectAllnet3000
        then begin
               MyConnectAllnet3000 := False;
               IdHTTP2.Disconnect;
               BtnConnectAllnet3000.Caption := 'Connect';
               TimerAllnet3000.Enabled  := False;
               ClearAllnet3000;
             end
        else begin
                 IdHTTP2.Host := IP_Allnet3000.Text;
               try
                 {$I-}
                   IdHTTP2.Connect;
                   MyConnectAllnet3000 := IdHTTP2.Connected;
                 {$I+}
               except
                 MyConnectAllnet3000 := False;
               end;

               If MyConnectAllnet3000
                 then begin
                        BtnConnectAllnet3000.Caption := 'Disconnect';
                        MyConnectAllnet3000          := True;
                        TimerAllnet3000.Enabled      := True;
                      end
                 else begin
                        showmessage('connection to 3000RF:' + IdHTTP1.Host + ' not possible');
                        BtnConnectAllnet3000.Caption := 'Connect';
                        MyConnectAllnet3000          := False;
                        TimerAllnet3000.Enabled      := False;
                      end;
             end;
end;





Procedure UpDateRF3000Status;
begin
  MyCmd := 'http://' + Form1.IdHTTP1.Host + '/xml';
  RecvString := Form1.IdHTTP1.Get(MyCmd);

  If RecvString = '' then exit;
  //-----

  for i:= 0 to 15 do
    begin
      //RFSocketName
      RFSocketName[i] := MyXMLGet('n'  +IntToStr(i) );

      //RFStatus
      MyHelpStr       := MyXMLGet('t'  +IntToStr(i) );
      If MyHelpStr = '0'
        then begin
               RFStatus    [i] := 'Off'
             end
        else begin
               RFStatus    [i] := 'On';
             end;

      Form1.GridRFPlugs.cells[0,i] :=RFSocketName[i] ;
      Form1.GridRFPlugs.cells[1,i] :=RFStatus[i]     ;
    end;

  RTDate           := MyXMLGet('date');
  Form1.EDate    .Text := RTDate;

  RTTime           := MyXMLGet('time');
  Form1.ETime    .Text := RTTime;

  RFFirmwareStatus := MyXMLGet('fw');
  Form1.EFirmware.Text := RFFirmwareStatus;



{  for i:= 0 to 7 do
    begin
      //SensorStatus
      SensorStatus[i] := MyXMLGet('s'  + IntToStr(i) );
      //-16383 -> not connected
      //If (StrToInt(SensorStatus[i]) <= -16380) then SensorStatus[i] := 'Sensor not connected';

      Form1.GridSensors.cells[0,i] :=IntToStr(i) ;
      Form1.GridSensors.cells[1,i] :=SensorStatus[i] ;

    end;
}

end;


Procedure UpDateAllnet3000Status;
Var
  MyReal : Real;
begin
  MyCmd := 'http://' + Form1.IdHTTP2.Host + '/xml';
  RecvString := Form1.IdHTTP2.Get(MyCmd);

  If RecvString = '' then exit;
  //-----


  for i:= 0 to 7 do
    begin
      //SensorStatus
      SensorName  [i] := MyXMLGet('n'  + IntToStr(i) );
      SensorStatus[i] := MyXMLGet('t'  + IntToStr(i) );
      Min         [i] := MyXMLGet('min'+ IntToStr(i) );
      Max         [i] := MyXMLGet('max'+ IntToStr(i) );
      Low         [i] := MyXMLGet('l'  + IntToStr(i) );
      High        [i] := MyXMLGet('h'  + IntToStr(i) );
      Typ         [i] := MyXMLGet('s'  + IntToStr(i) );

      Form1.GridSensors.cells[0,i] :=SensorName[i]   ;
      Form1.GridSensors.cells[1,i] :=SensorStatus[i] ;
      Form1.GridSensors.cells[2,i] :=Min[i] ;
      Form1.GridSensors.cells[3,i] :=Max[i] ;
      Form1.GridSensors.cells[5,i] :=Low[i] ;
      Form1.GridSensors.cells[4,i] :=High[i] ;
      Form1.GridSensors.cells[6,i] :=Typ[i] ;

      case i of
        0 : Form1.SName1.Caption := SensorName[i];
        1 : Form1.SName2.Caption := SensorName[i];
        2 : Form1.SName3.Caption := SensorName[i];
        3 : Form1.SName4.Caption := SensorName[i];
        4 : Form1.SName5.Caption := SensorName[i];
        5 : Form1.SName6.Caption := SensorName[i];
        6 : Form1.SName7.Caption := SensorName[i];
        7 : Form1.SName8.Caption := SensorName[i];
      end; // of case

    end;


  RTDate3000               := MyXMLGet('date');
  Form1.EDate3000.Text     := RTDate3000;

  RTTime3000               := MyXMLGet('time');
  Form1.ETime3000.Text     := RTTime3000;

  RFFirmwareStatus3000     := MyXMLGet('fw');
  Form1.EFirmware3000.Text := RFFirmwareStatus3000;


    If Form1.CB_S1.Checked
      then  begin
              {$I-} val(SensorStatus[0],MyReal,MyError); {$I+}
              Form1.Display_S1.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S1.Text) * StrToFloat(Form1.Mult_S1.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S1.Text
            end
      else  Form1.Display_S1.Caption := '-';

    If Form1.CB_S2.Checked
      then  begin
              {$I-} val(SensorStatus[1],MyReal,MyError); {$I+}
              Form1.Display_S2.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S2.Text) * StrToFloat(Form1.Mult_S2.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S2.Text
            end
      else  Form1.Display_S2.Caption := '-';

    If Form1.CB_S3.Checked
      then  begin
              {$I-} val(SensorStatus[2],MyReal,MyError); {$I+}
              Form1.Display_S3.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S3.Text) * StrToFloat(Form1.Mult_S3.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S3.Text
            end
      else  Form1.Display_S3.Caption := '-';

    If Form1.CB_S4.Checked
      then  begin
              {$I-} val(SensorStatus[3],MyReal,MyError); {$I+}
              Form1.Display_S4.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S4.Text) * StrToFloat(Form1.Mult_S4.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S4.Text
            end
      else  Form1.Display_S4.Caption := '-';

    If Form1.CB_S5.Checked
      then  begin
              {$I-} val(SensorStatus[4],MyReal,MyError); {$I+}
              Form1.Display_S5.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S5.Text) * StrToFloat(Form1.Mult_S5.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S5.Text
            end
      else  Form1.Display_S5.Caption := '-';

    If Form1.CB_S6.Checked
      then  begin
              {$I-} val(SensorStatus[5],MyReal,MyError); {$I+}
              Form1.Display_S6.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S6.Text) * StrToFloat(Form1.Mult_S6.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S6.Text
            end
      else  Form1.Display_S6.Caption := '-';

    If Form1.CB_S7.Checked
      then  begin
              {$I-} val(SensorStatus[6],MyReal,MyError); {$I+}
              Form1.Display_S7.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S7.Text) * StrToFloat(Form1.Mult_S7.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S7.Text
            end
      else  Form1.Display_S7.Caption := '-';

    If Form1.CB_S8.Checked
      then  begin
              {$I-} val(SensorStatus[7],MyReal,MyError); {$I+}
              Form1.Display_S8.Caption := FloatToStrF (MyReal + StrToFloat(Form1.Offset_S8.Text) * StrToFloat(Form1.Mult_S8.Text),ffGeneral,7,1) + ' ' + Form1.Unit_S8.Text
            end
      else  Form1.Display_S8.Caption := '-';

end;



procedure TForm1.TimerRF3000Timer(Sender: TObject);
begin
  UpDateRF3000Status;
end;

procedure TForm1.TimerAllnet3000Timer(Sender: TObject);
begin
  UpDateAllnet3000Status;
end;



procedure TForm1.FormCreate(Sender: TObject);
Var
 Count : Integer;
 MyLineStr : String;
begin
   Form1.GridRFPlugs.Colwidths[0] := 300;
   Form1.GridRFPlugs.Colwidths[1] := 50;

   Form1.GridSensors.Colwidths[0] := 200;
   Form1.GridSensors.Colwidths[1] := 50;
   Form1.GridSensors.Colwidths[2] := 50;
   Form1.GridSensors.Colwidths[3] := 50;
   Form1.GridSensors.Colwidths[4] := 50;
   Form1.GridSensors.Colwidths[5] := 50;
   Form1.GridSensors.Colwidths[6] := 50;


   If FileExists(MyTextfile)
     then begin
             AssignFile(MyF,MyTextfile);
             Reset(MyF);
             Count := 0;
             while not(EOF(MyF)) do
               begin
                 Inc(Count);
                 ReadLn(MyF,MyLineStr);
                 case count of
                   1: IP_RF3000.Text := MyLineStr;
                   2: IP_Allnet3000.Text := MyLineStr;
                   3: If MyLineStr = 'TRUE' then CB_S1.Checked := True else CB_S1.Checked := False;
                   4: If MyLineStr = 'TRUE' then CB_S2.Checked := True else CB_S2.Checked := False;
                   5: If MyLineStr = 'TRUE' then CB_S3.Checked := True else CB_S3.Checked := False;
                   6: If MyLineStr = 'TRUE' then CB_S4.Checked := True else CB_S4.Checked := False;
                   7: If MyLineStr = 'TRUE' then CB_S5.Checked := True else CB_S5.Checked := False;
                   8: If MyLineStr = 'TRUE' then CB_S6.Checked := True else CB_S6.Checked := False;
                   9: If MyLineStr = 'TRUE' then CB_S7.Checked := True else CB_S7.Checked := False;
                   10:If MyLineStr = 'TRUE' then CB_S8.Checked := True else CB_S8.Checked := False;
                   11:Offset_S1.Text := MyLineStr;
                   12:Offset_S2.Text := MyLineStr;
                   13:Offset_S3.Text := MyLineStr;
                   14:Offset_S4.Text := MyLineStr;
                   15:Offset_S5.Text := MyLineStr;
                   16:Offset_S6.Text := MyLineStr;
                   17:Offset_S7.Text := MyLineStr;
                   18:Offset_S8.Text := MyLineStr;

                   19:Mult_S1.Text := MyLineStr;
                   20:Mult_S2.Text := MyLineStr;
                   21:Mult_S3.Text := MyLineStr;
                   22:Mult_S4.Text := MyLineStr;
                   23:Mult_S5.Text := MyLineStr;
                   24:Mult_S6.Text := MyLineStr;
                   25:Mult_S7.Text := MyLineStr;
                   26:Mult_S8.Text := MyLineStr;

                   27:Unit_S1.Text := MyLineStr;
                   28:Unit_S2.Text := MyLineStr;
                   29:Unit_S3.Text := MyLineStr;
                   30:Unit_S4.Text := MyLineStr;
                   31:Unit_S5.Text := MyLineStr;
                   32:Unit_S6.Text := MyLineStr;
                   33:Unit_S7.Text := MyLineStr;
                   34:Unit_S8.Text := MyLineStr;
                 end; //of case
               end;
            CloseFile(MyF);
          end;

end;




procedure TForm1.FormDestroy(Sender: TObject);
begin
  //Write Ini-File

  AssignFile(MyF,MyTextfile);
  ReWrite(MyF);
  WriteLn(MyF, IP_RF3000.Text               );
  WriteLn(MyF, IP_Allnet3000.Text );
  WriteLn(MyF, CB_S1.Checked                );
  WriteLn(MyF, CB_S2.Checked                );
  WriteLn(MyF, CB_S3.Checked                );
  WriteLn(MyF, CB_S4.Checked                );
  WriteLn(MyF, CB_S5.Checked                );
  WriteLn(MyF, CB_S6.Checked                );
  WriteLn(MyF, CB_S7.Checked                );
  WriteLn(MyF, CB_S8.Checked                );

  WriteLn(MyF, Offset_S1.Text     );
  WriteLn(MyF, Offset_S2.Text     );
  WriteLn(MyF, Offset_S3.Text     );
  WriteLn(MyF, Offset_S4.Text     );
  WriteLn(MyF, Offset_S5.Text     );
  WriteLn(MyF, Offset_S6.Text     );
  WriteLn(MyF, Offset_S7.Text     );
  WriteLn(MyF, Offset_S8.Text     );

  WriteLn(MyF, Mult_S1.Text        );
  WriteLn(MyF, Mult_S2.Text        );
  WriteLn(MyF, Mult_S3.Text        );
  WriteLn(MyF, Mult_S4.Text        );
  WriteLn(MyF, Mult_S5.Text        );
  WriteLn(MyF, Mult_S6.Text        );
  WriteLn(MyF, Mult_S7.Text        );
  WriteLn(MyF, Mult_S8.Text        );

  WriteLn(MyF, Unit_S1.Text        );
  WriteLn(MyF, Unit_S2.Text        );
  WriteLn(MyF, Unit_S3.Text        );
  WriteLn(MyF, Unit_S4.Text        );
  WriteLn(MyF, Unit_S5.Text        );
  WriteLn(MyF, Unit_S6.Text        );
  WriteLn(MyF, Unit_S7.Text        );
  WriteLn(MyF, Unit_S8.Text        );

  CloseFile(MyF);
end;

end.

